#include "GameObj.H"
#include "GameStateModule.H"
#include "Game.H"
#include "GameChanges.H"
#include "GameTile.H"
#include "ServerObjData.H"
#include "Global.H"
#include <map>
#include <math.h>

#include "formationCircle.H"
#define PI 3.14159265359
static const float EXPECTED_DAMAGE = 5.5;
static const int CIRCLE_RADIUS = 64;

using namespace std;
/*
formationCircle::formationCircle() {
	formationCircle(ScalarPoint(0,0));
}
*/
formationCircle::formationCircle() {
	 center = ScalarPoint(0,0);
	 state = FORMING_INITIAL_CIRCLE;
	 close=false; //fixme
	 
	disc0.insert(make_pair(0,ScalarPoint(0,9)));
	disc0.insert(make_pair(1,ScalarPoint(8,-5)));
	disc0.insert(make_pair(2,ScalarPoint(-8,-5)));
	disc1.insert(make_pair(0,ScalarPoint(0,27)));
	disc1.insert(make_pair(1,ScalarPoint(17,21)));
	disc1.insert(make_pair(2,ScalarPoint(27,5)));
	disc1.insert(make_pair(3,ScalarPoint(24,-14)));
	disc1.insert(make_pair(4,ScalarPoint(9,-26)));
	disc1.insert(make_pair(5,ScalarPoint(-9,-26)));
	disc1.insert(make_pair(6,ScalarPoint(-24,-14)));
	disc1.insert(make_pair(7,ScalarPoint(-27,5)));
	disc1.insert(make_pair(8,ScalarPoint(-17,21)));
	disc2.insert(make_pair(0,ScalarPoint(0,45)));
	disc2.insert(make_pair(1,ScalarPoint(17,42)));
	disc2.insert(make_pair(2,ScalarPoint(32,32)));
	disc2.insert(make_pair(3,ScalarPoint(42,17)));
	disc2.insert(make_pair(4,ScalarPoint(45,0)));
	disc2.insert(make_pair(5,ScalarPoint(42,-17)));
	disc2.insert(make_pair(6,ScalarPoint(32,-32)));
	disc2.insert(make_pair(7,ScalarPoint(17,-42)));
	disc2.insert(make_pair(8,ScalarPoint(0,-45)));
	disc2.insert(make_pair(9,ScalarPoint(-17,-42)));
	disc2.insert(make_pair(10,ScalarPoint(-32,-32)));
	disc2.insert(make_pair(11,ScalarPoint(-42,-17)));
	disc2.insert(make_pair(12,ScalarPoint(-45,0)));
	disc2.insert(make_pair(13,ScalarPoint(-42,17)));
	disc2.insert(make_pair(14,ScalarPoint(-32,32)));
	disc2.insert(make_pair(15,ScalarPoint(-17,42)));
	disc3.insert(make_pair(0,ScalarPoint(0,63)));
	disc3.insert(make_pair(1,ScalarPoint(18,61)));
	disc3.insert(make_pair(2,ScalarPoint(34,53)));
	disc3.insert(make_pair(3,ScalarPoint(48,42)));
	disc3.insert(make_pair(4,ScalarPoint(58,26)));
	disc3.insert(make_pair(5,ScalarPoint(63,9)));
	disc3.insert(make_pair(6,ScalarPoint(63,-9)));
	disc3.insert(make_pair(7,ScalarPoint(58,-26)));
	disc3.insert(make_pair(8,ScalarPoint(48,-42)));
	disc3.insert(make_pair(9,ScalarPoint(34,-53)));
	disc3.insert(make_pair(10,ScalarPoint(18,-61)));
	disc3.insert(make_pair(11,ScalarPoint(0,-63)));
	disc3.insert(make_pair(12,ScalarPoint(-18,-61)));
	disc3.insert(make_pair(13,ScalarPoint(-34,-53)));
	disc3.insert(make_pair(14,ScalarPoint(-48,-42)));
	disc3.insert(make_pair(15,ScalarPoint(-58,-26)));
	disc3.insert(make_pair(16,ScalarPoint(-63,-9)));
	disc3.insert(make_pair(17,ScalarPoint(-63,9)));
	disc3.insert(make_pair(18,ScalarPoint(-58,26)));
	disc3.insert(make_pair(19,ScalarPoint(-48,42)));
	disc3.insert(make_pair(20,ScalarPoint(-34,53)));
	disc3.insert(make_pair(21,ScalarPoint(-18,61)));

	
	circleDiscs.insert(make_pair(0,disc0));
	circleDiscs.insert(make_pair(1,disc1));
	circleDiscs.insert(make_pair(2,disc2));
	circleDiscs.insert(make_pair(3,disc3));
	
	circleSlots[0] = ScalarPoint (-104, -15);
	circleSlots[1] = ScalarPoint (-104, 15);
	circleSlots[2] = ScalarPoint (-96, -44);
	circleSlots[3] = ScalarPoint (-96, 44);
	circleSlots[4] = ScalarPoint (-79, -69);
	circleSlots[5] = ScalarPoint (-79, 69);
	circleSlots[6] = ScalarPoint (-75, 0);
	circleSlots[7] = ScalarPoint (-69, -29);
	circleSlots[8] = ScalarPoint (-69, 29);
	circleSlots[9] = ScalarPoint (-57, -88);
	circleSlots[10] = ScalarPoint (-57, 88);
	circleSlots[11] = ScalarPoint (-53, -53);
	circleSlots[12] = ScalarPoint (-53, 53);
	circleSlots[13] = ScalarPoint (-44, 8);
	circleSlots[14] = ScalarPoint (-39, -23);
	circleSlots[15] = ScalarPoint (-30, -101);
	circleSlots[16] = ScalarPoint (-30, 101);
	circleSlots[17] = ScalarPoint (-29, -69);
	circleSlots[18] = ScalarPoint (-29, 34);
	circleSlots[19] = ScalarPoint (-29, 69);
	circleSlots[20] = ScalarPoint (-15, -42);
	circleSlots[21] = ScalarPoint (-13, -8);
	circleSlots[22] = ScalarPoint (0, -105);
	circleSlots[23] = ScalarPoint (0, -75);
	circleSlots[24] = ScalarPoint (0, 15);
	circleSlots[25] = ScalarPoint (0, 45);
	circleSlots[26] = ScalarPoint (0, 75);
	circleSlots[27] = ScalarPoint (0, 105);
	circleSlots[28] = ScalarPoint (13, -7);
	circleSlots[29] = ScalarPoint (15, -42);
	circleSlots[30] = ScalarPoint (29, -69);
	circleSlots[31] = ScalarPoint (29, 34);
	circleSlots[32] = ScalarPoint (29, 69);
	circleSlots[33] = ScalarPoint (30, -101);
	circleSlots[34] = ScalarPoint (30, 101);
	circleSlots[35] = ScalarPoint (39, -22);
	circleSlots[36] = ScalarPoint (44, 8);
	circleSlots[37] = ScalarPoint (53, -53);
	circleSlots[38] = ScalarPoint (53, 53);
	circleSlots[39] = ScalarPoint (57, -88);
	circleSlots[40] = ScalarPoint (57, 88);
	circleSlots[41] = ScalarPoint (69, -29);
	circleSlots[42] = ScalarPoint (69, 29);
	circleSlots[43] = ScalarPoint (75, 0);
	circleSlots[44] = ScalarPoint (79, -69);
	circleSlots[45] = ScalarPoint (79, 69);
	circleSlots[46] = ScalarPoint (96, -44);
	circleSlots[47] = ScalarPoint (96, 44);
	circleSlots[48] = ScalarPoint (104, -15);
	circleSlots[49] = ScalarPoint (104, 15);
	
	circleIdxToDiscIdxMap.insert(make_pair(0,ScalarPoint(3,16)));
	circleIdxToDiscIdxMap.insert(make_pair(1,ScalarPoint(3,17)));
	circleIdxToDiscIdxMap.insert(make_pair(2,ScalarPoint(3,15)));
	circleIdxToDiscIdxMap.insert(make_pair(3,ScalarPoint(3,18)));
	circleIdxToDiscIdxMap.insert(make_pair(4,ScalarPoint(3,14)));
	circleIdxToDiscIdxMap.insert(make_pair(5,ScalarPoint(3,19)));
	circleIdxToDiscIdxMap.insert(make_pair(6,ScalarPoint(2,12)));
	circleIdxToDiscIdxMap.insert(make_pair(7,ScalarPoint(2,11)));
	circleIdxToDiscIdxMap.insert(make_pair(8,ScalarPoint(2,13)));
	circleIdxToDiscIdxMap.insert(make_pair(9,ScalarPoint(3,13)));
	circleIdxToDiscIdxMap.insert(make_pair(10,ScalarPoint(3,20)));
	circleIdxToDiscIdxMap.insert(make_pair(11,ScalarPoint(2,10)));
	circleIdxToDiscIdxMap.insert(make_pair(12,ScalarPoint(2,14)));
	circleIdxToDiscIdxMap.insert(make_pair(13,ScalarPoint(1,7)));
	circleIdxToDiscIdxMap.insert(make_pair(14,ScalarPoint(1,6)));
	circleIdxToDiscIdxMap.insert(make_pair(15,ScalarPoint(3,12)));
	circleIdxToDiscIdxMap.insert(make_pair(16,ScalarPoint(3,21)));
	circleIdxToDiscIdxMap.insert(make_pair(17,ScalarPoint(2,9)));
	circleIdxToDiscIdxMap.insert(make_pair(18,ScalarPoint(1,8)));
	circleIdxToDiscIdxMap.insert(make_pair(19,ScalarPoint(2,15)));
	circleIdxToDiscIdxMap.insert(make_pair(20,ScalarPoint(1,5)));
	circleIdxToDiscIdxMap.insert(make_pair(21,ScalarPoint(0,2)));
	circleIdxToDiscIdxMap.insert(make_pair(22,ScalarPoint(3,11)));
	circleIdxToDiscIdxMap.insert(make_pair(23,ScalarPoint(2,8)));
	circleIdxToDiscIdxMap.insert(make_pair(24,ScalarPoint(0,0)));
	circleIdxToDiscIdxMap.insert(make_pair(25,ScalarPoint(1,0)));
	circleIdxToDiscIdxMap.insert(make_pair(26,ScalarPoint(2,0)));
	circleIdxToDiscIdxMap.insert(make_pair(27,ScalarPoint(3,0)));
	circleIdxToDiscIdxMap.insert(make_pair(28,ScalarPoint(0,1)));
	circleIdxToDiscIdxMap.insert(make_pair(29,ScalarPoint(1,4)));
	circleIdxToDiscIdxMap.insert(make_pair(30,ScalarPoint(2,7)));
	circleIdxToDiscIdxMap.insert(make_pair(31,ScalarPoint(1,1)));
	circleIdxToDiscIdxMap.insert(make_pair(32,ScalarPoint(2,1)));
	circleIdxToDiscIdxMap.insert(make_pair(33,ScalarPoint(3,10)));
	circleIdxToDiscIdxMap.insert(make_pair(34,ScalarPoint(3,1)));
	circleIdxToDiscIdxMap.insert(make_pair(35,ScalarPoint(1,3)));
	circleIdxToDiscIdxMap.insert(make_pair(36,ScalarPoint(1,2)));
	circleIdxToDiscIdxMap.insert(make_pair(37,ScalarPoint(2,6)));
	circleIdxToDiscIdxMap.insert(make_pair(38,ScalarPoint(2,2)));
	circleIdxToDiscIdxMap.insert(make_pair(39,ScalarPoint(3,9)));
	circleIdxToDiscIdxMap.insert(make_pair(40,ScalarPoint(3,2)));
	circleIdxToDiscIdxMap.insert(make_pair(41,ScalarPoint(2,5)));
	circleIdxToDiscIdxMap.insert(make_pair(42,ScalarPoint(2,3)));
	circleIdxToDiscIdxMap.insert(make_pair(43,ScalarPoint(2,4)));
	circleIdxToDiscIdxMap.insert(make_pair(44,ScalarPoint(3,8)));
	circleIdxToDiscIdxMap.insert(make_pair(45,ScalarPoint(3,3)));
	circleIdxToDiscIdxMap.insert(make_pair(46,ScalarPoint(3,7)));
	circleIdxToDiscIdxMap.insert(make_pair(47,ScalarPoint(3,4)));
	circleIdxToDiscIdxMap.insert(make_pair(48,ScalarPoint(3,6)));
	circleIdxToDiscIdxMap.insert(make_pair(49,ScalarPoint(3,5)));

	/* [3,1],[9,3],[16,5],[22,7] R = l[1] * 2*r * 1.4 */
	circleSlotsClose[0] = ScalarPoint (-60, -9);
	circleSlotsClose[1] = ScalarPoint (-60, 9);
	circleSlotsClose[2] = ScalarPoint (-55, -25);
	circleSlotsClose[3] = ScalarPoint (-55, 25);
	circleSlotsClose[4] = ScalarPoint (-46, -40);
	circleSlotsClose[5] = ScalarPoint (-46, 40);
	circleSlotsClose[6] = ScalarPoint (-44, 0);
	circleSlotsClose[7] = ScalarPoint (-40, -17);
	circleSlotsClose[8] = ScalarPoint (-40, 17);
	circleSlotsClose[9] = ScalarPoint (-33, -51);
	circleSlotsClose[10] = ScalarPoint (-33, 51);
	circleSlotsClose[11] = ScalarPoint (-31, -31);
	circleSlotsClose[12] = ScalarPoint (-31, 31);
	circleSlotsClose[13] = ScalarPoint (-26, 5);
	circleSlotsClose[14] = ScalarPoint (-23, -13);
	circleSlotsClose[15] = ScalarPoint (-17, -58);
	circleSlotsClose[16] = ScalarPoint (-17, 58);
	circleSlotsClose[17] = ScalarPoint (-17, -40);
	circleSlotsClose[18] = ScalarPoint (-17, 20);
	circleSlotsClose[19] = ScalarPoint (-17, 40);
	circleSlotsClose[20] = ScalarPoint (-9, -25);
	circleSlotsClose[21] = ScalarPoint (-8, -4);
	circleSlotsClose[22] = ScalarPoint (0, -61);
	circleSlotsClose[23] = ScalarPoint (0, -44);
	circleSlotsClose[24] = ScalarPoint (0, 9);
	circleSlotsClose[25] = ScalarPoint (0, 26);
	circleSlotsClose[26] = ScalarPoint (0, 44);
	circleSlotsClose[27] = ScalarPoint (0, 61);
	circleSlotsClose[28] = ScalarPoint (8, -4);
	circleSlotsClose[29] = ScalarPoint (9, -25);
	circleSlotsClose[30] = ScalarPoint (17, -40);
	circleSlotsClose[31] = ScalarPoint (17, 20);
	circleSlotsClose[32] = ScalarPoint (17, 40);
	circleSlotsClose[33] = ScalarPoint (17, -58);
	circleSlotsClose[34] = ScalarPoint (17, 58);
	circleSlotsClose[35] = ScalarPoint (23, -13);
	circleSlotsClose[36] = ScalarPoint (26, 5);
	circleSlotsClose[37] = ScalarPoint (31, -31);
	circleSlotsClose[38] = ScalarPoint (31, 31);
	circleSlotsClose[39] = ScalarPoint (33, -51);
	circleSlotsClose[40] = ScalarPoint (33, 51);
	circleSlotsClose[41] = ScalarPoint (40, -17);
	circleSlotsClose[42] = ScalarPoint (40, 17);
	circleSlotsClose[43] = ScalarPoint (44, 0);
	circleSlotsClose[44] = ScalarPoint (46, -40);
	circleSlotsClose[45] = ScalarPoint (46, 40);
	circleSlotsClose[46] = ScalarPoint (55, -25);
	circleSlotsClose[47] = ScalarPoint (55, 25);
	circleSlotsClose[48] = ScalarPoint (60, -9);
	circleSlotsClose[49] = ScalarPoint (60, 9);

}

void formationCircle::moveCircle(GameStateModule* gsm) {

	const Game &game = gsm->get_game();
  const sint4 cid = game.get_client_player();
  const Map<GameTile> &map = game.get_map();
  const Game::ObjCont &objs = game.get_objs(cid);
  //const sint4 points_x = map.get_width()  * game.get_tile_points();
  //const sint4 points_y = map.get_height() * game.get_tile_points(); 
	bool notInFormation;
	ScalarPoint currentCenter = getCenter();
	ScalarPoint newCenter; 
	switch (state){
      case FORMING_INITIAL_CIRCLE:
				notInFormation = false;
	
  			FORALL (objs, it) {
    			GameObj *gob = (*it)->get_GameObj();
   				if (gob && gob->sod.in_game && *gob->sod.x >= 0 && !gob->is_dead()) { 
   					ScalarPoint t;
   					if (!close)
							t = getGobPos(gob->get_obj_id(gob));     
						else
							t= getGobDiscPos(gob->get_obj_id(gob)); 
     				 if (t != ScalarPoint(*gob->sod.x,*gob->sod.y)) {
							 // object not dead and not in desired position yet => move action
     				 	notInFormation = true;
     				 	if (*gob->sod.speed == 0) { // && !gob->is_pending_action()) { 
																// object speed == 0 => stuck => evasive move
								t.x = *gob->sod.x - 6 + std::rand() % 12;
								t.y = *gob->sod.y - 6 + std::rand() % 12;
								/*
								const sintptr *hd = gob->get_int_ptr("heading");
								int headingDeg;
								double headingRad;
								
								
								if (hd) {
    							headingDeg = GameConst::angle_from_dir(*hd, GameConst::HEADING_N);
    							headingRad = PI/180 * ((headingDeg+360)%360) ;
    						}
								cout << "marine " << gob->get_obj_id(gob) << " is stuck with heading " <<
								headingDeg << endl;
								if (rand()%2 == 0) {
									t.x = *gob->sod.x - 12*sin(headingRad + PI/2);	
									t.y = *gob->sod.y - 12*cos(headingRad + PI/2);							
								}
								else {
									t.x = *gob->sod.x + 12*sin(headingRad + PI/2);	
									t.y = *gob->sod.y + 12*cos(headingRad + PI/2);
								}
								//cout << "pos: " << *gob->sod.x << "," << *gob->sod.y << " going to: " << t.x << "," << t.y << endl;
							*/
							}
							
							//cout << "target position = (" << t.x << "," << t.y << ")" << endl;
							if (t.x >= 0 && t.y >= 0 ) {
								Vector<sint4> params;
								params.push_back(t.x);
								params.push_back(t.y);
								params.push_back(*gob->sod.max_speed);
								gob->set_action("move", params);
							}
      			}
    			}
  			}
  
  			if (!notInFormation) {
  			//cout << "move closer" << endl;
  				if (!close)
  				state=FORMING_CIRCLE;
  				else
  				state=MOVING;
  			}
  		break;
  		
  		case FORMING_CIRCLE:
  			circleSlots=circleSlotsClose;
  			//updateCirclePos();
  			initializeDiscs();
  			state = FORMING_INITIAL_CIRCLE;
  			close = true;
  		break;
  		
  		
  		case MOVING:
  			newCenter = ScalarPoint(0,0);
  			newCenter = nextPos(gsm);
  			/*
  			while (newCenter.x<CIRCLE_RADIUS+3||	points_x-CIRCLE_RADIUS+3<newCenter.x || newCenter.y<CIRCLE_RADIUS+3 ||	points_y-CIRCLE_RADIUS+3<newCenter.y)
  				//newCenter = ScalarPoint(512,512);
  				newCenter = ScalarPoint(currentCenter.x - 80 + std::rand() % 160, currentCenter.y - 80 + std::rand() % 160);
  			*/
  			setCenter(newCenter);
  			state=FORMING_INITIAL_CIRCLE;
  			
  			cout << "new Center: " << newCenter.x << "," << newCenter.y << endl;
  			
  			/*
  			FORALL (objs, it) {
    			GameObj *gob = (*it)->get_GameObj();
   				if (gob && gob->sod.in_game && *gob->sod.x >= 0 && !gob->is_dead()) { 
   					ScalarPoint t;
						t = getGobPos(gob->get_obj_id(gob));     
     				 if (t != ScalarPoint(*gob->sod.x,*gob->sod.y)) {
							 // object not dead and not in desired position yet => move action
     				 	notInFormation = true;
     				 	if (*gob->sod.speed == 0 && !gob->is_pending_action()) { 
																// object speed == 0 => stuck => evasive move
								t.x = *gob->sod.x - 6 + std::rand() % 12;
								t.y = *gob->sod.y - 6 + std::rand() % 12;
								
							}
							
							//cout << "target position = (" << t.x << "," << t.y << ")" << endl;
							if (t.x >= 0 && t.y >= 0 ) {
								Vector<sint4> params;
								params.push_back(t.x);
								params.push_back(t.y);
								params.push_back(*gob->sod.max_speed);
								gob->set_action("move", params);
							}
      			}
     				//else
      				//notInFormation = false;
    			}
    
  			}*/
  		break;
  		default:
  			cout << "unknown state" << endl;
	}
}

void formationCircle::shoot(GameStateModule* gsm) {
	//cout << "shooting" << endl;
	const Game &game = gsm->get_game();
	sint4 vf = game.get_view_frame();
	set<GameObj*> assShooters;
	multimap<int, GameObj*>::iterator oit;
	for (oit=potTargets.begin();oit!=potTargets.end();++oit) {
	//cout << "looping targets" << endl;
		GameObj* target = (oit->second)->get_GameObj();
		float health = oit->first; // current healthpoints of opponent;
		set<GameObj*>::iterator sit;
		set<GameObj*>::iterator nextSit;
		sit = myShooters.begin();
		while (health > 0 && sit != myShooters.end()){
			nextSit = sit;
			++nextSit;
		//cout << "looping shooters" << endl;
			GameObj* shooter = (*sit)->get_GameObj();
			if (shooter && shooter->sod.in_game && *shooter->sod.x >= 0 && !shooter->is_dead()) {
				ScriptObj *weapon = shooter->component("weapon");
				sintptr *prange = weapon->get_int_ptr("max_ground_range");
			
			
				sintptr *cooldown = weapon->get_int_ptr("cooldown");
				sintptr *lastFired = weapon->get_int_ptr("last_fired");
			
				if(*lastFired + *cooldown <= vf) {
					const sint4 range2 = *prange * *prange;
					real8 dist2 =
										square(real8(*shooter->sod.x - *target->sod.x)) +
										square(real8(*shooter->sod.y - *target->sod.y));

					if (dist2 <= range2) {
						health = health - EXPECTED_DAMAGE;
				
						Vector<sint4> args;
						args.push_back(game.get_cplayer_info().get_id(target));
						shooter->component("weapon")->set_action("attack", args, 32);
						//cout << "shooting" << endl;

						assShooters.insert(shooter);	
						myShooters.erase(sit);
						sit = nextSit;
						continue;
					}
				}
			}
			++sit;
		}
						
	}
	
	myShooters.insert(assShooters.begin(),assShooters.end());
	assShooters.clear();
	
}

ScalarPoint formationCircle::nextPos(GameStateModule* gsm) {	
	const Game &game = gsm->get_game();
  const Map<GameTile> &map = game.get_map();
  const sint4 points_x = map.get_width()  * game.get_tile_points();
  const sint4 points_y = map.get_height() * game.get_tile_points();
   
	ScalarPoint cog = ScalarPoint(0,0);
	int n = 0;
	multimap<int, GameObj*>::iterator oit;
	multimap<double, ScalarPoint> posSort;
	multimap<double, ScalarPoint>::iterator psIt;
	multimap<double, ScalarPoint>::reverse_iterator rpsIt;
	ScalarPoint targetPos = ScalarPoint(-1,-1);
	
	for (oit=potTargets.begin();oit!=potTargets.end();++oit) {
		GameObj* opponent = (oit->second)->get_GameObj();
		++n;
		cog.x = cog.x + (*opponent->sod.x-cog.x)/n;
		cog.y = cog.y + (*opponent->sod.y-cog.y)/n;
	}
	double dist2;
	for (oit=potTargets.begin();oit!=potTargets.end();++oit) {
		GameObj* opponent = (oit->second)->get_GameObj();
		dist2 = pow((double)(cog.x-*opponent->sod.x) , 2)+pow((double)(cog.y-*opponent->sod.y) , 2);
			posSort.insert(make_pair(dist2, ScalarPoint(*opponent->sod.x,*opponent->sod.y))); 
	}
	
	for (rpsIt=posSort.rbegin();rpsIt!=posSort.rend();++rpsIt) {
		targetPos = rpsIt->second;
	  if (targetPos.x<CIRCLE_RADIUS+3 || points_x-(CIRCLE_RADIUS+3) < targetPos.x || targetPos.y<CIRCLE_RADIUS+3 || points_y-(CIRCLE_RADIUS+3) < targetPos.y)
			targetPos = ScalarPoint(-1,-1);
		else
			break;
	}
	
	if (targetPos == ScalarPoint(-1,-1)) {
		targetPos = posSort.rbegin()->second;
		if (targetPos.x < CIRCLE_RADIUS+3)
			targetPos.x = CIRCLE_RADIUS+3;
		if (points_x-(CIRCLE_RADIUS+3) < targetPos.x)
			targetPos.x = points_x-(CIRCLE_RADIUS+3);
		if (targetPos.y < CIRCLE_RADIUS+3)
			targetPos.y = CIRCLE_RADIUS+3;
		if (points_y-(CIRCLE_RADIUS+3) < targetPos.y)
			targetPos.y = points_y-(CIRCLE_RADIUS+3);	
	}
	
	
	return targetPos;
}

void formationCircle::rotateDiscs() {
	std::map<sint4, ScalarPoint>::iterator it;
	for (it=gobDiscSlot.begin(); it!=gobDiscSlot.end(); ++it) {
		++(it->second).y;
		if ((it->second).y >= circleDiscs[(it->second).x].size()){
			cout << (it->second).y << endl;
			(it->second).y = 0;
		}
	}

}
/** returns the true position of a slot in a circle
		@param slot the number of the slot

*/	
ScalarPoint formationCircle::getSlotPos(int slot) {
	return ScalarPoint(circleSlots[slot].x + center.x, circleSlots[slot].y + center.y);
}


/** returns pointer to GameObj which is assigned to a slot
		@param slot the number of the slot

*/
GameObj* formationCircle::getGobInSlot(int slot) {
	return slotAssign[slot];
}

/** returns the number of the slot a given GameObj is assigned to
		@param gob pointer to the GameObj
*/
int formationCircle::getSlot(GameObj* gob) {
	std::map<int, GameObj*>::iterator it;
		
	for (it = slotAssign.begin(); it != slotAssign.end(); ++it) {
		if (it->second == gob) continue;
	}
	return it->first;
}

/** assigns a slot to a given GameObj
		@param gob pointer to the GameObj
		@param slot number of the slot

*/
void formationCircle::setSlot(GameObj* gob, int slot) {
	slotAssign[slot] = gob;
	gobCirclePos[gob->get_obj_id(gob)] = circleSlots[slot];
}

void formationCircle::initializeDiscs() {
	std::map<int, GameObj*>::iterator saIt;
	for (saIt=slotAssign.begin(); saIt!=slotAssign.end(); ++saIt) {
	Disc disc;
	ScalarPoint pos;
		GameObj* gob = saIt->second;
		ScalarPoint discIdx = circleIdxToDiscIdxMap[saIt->first];
		gobDiscSlot.insert(make_pair(gob->get_obj_id(gob), discIdx));
		//debugging:
		//disc = circleDiscs[discIdx.x];
		//pos = disc[discIdx.y];
		//cout << "slot " << saIt->first << " objID " <<  gob->get_obj_id(gob) << " discIndex (" << discIdx.x << "," << discIdx.y << ")" << endl;
		//cout << "slotPos: (" << circleSlotsClose[saIt->first].x << "," << circleSlotsClose[saIt->first].y << 
		//	") discPos: (" << pos.x << "," << pos.y << ")" << endl;
		//cout << "slot " << saIt->first << " slotPos: (" << circleSlotsClose[saIt->first].x << "," << circleSlotsClose[saIt->first].y <<
		//"); disc (" << discIdx.x << "," << discIdx.y << "): (" << circleDiscs[discIdx.x][discIdx.y].x << "," << circleDiscs[discIdx.x][discIdx.y].y << ")" << endl;
	}
}

/** defines the real position of the circel center on the game field
		@param pos real position of the circle center
*/
void formationCircle::setCenter(ScalarPoint pos) {
		center = pos;
}

ScalarPoint formationCircle::getCenter() {
	return center;
}
/** returns the real position a game object should be at
		this position depends on the current circle center, the slot of the Gameobj 
		and the relative positon to the circle center of the slot
		@param gobID the object Id of the GameObj 

*/
ScalarPoint formationCircle::getGobPos(sint4 gobID){
	if (gobID < gobCirclePos.size())
		return ScalarPoint (-1,-1);
	else
		return ScalarPoint(gobCirclePos[gobID].x + center.x, gobCirclePos[gobID].y + center.y);
}

ScalarPoint formationCircle::getGobDiscPos(sint4 gobID) {
	ScalarPoint discIdx = gobDiscSlot[gobID];
	sint4 returnX = circleDiscs[discIdx.x][discIdx.y].x + center.x;
	sint4 returnY = circleDiscs[discIdx.x][discIdx.y].y + center.y;
	//Disc disc = (circleDiscs[discIdx.x]);
	//cout << " disc Index (" << discIdx.x<< "," << discIdx.y << ")" << " pos (" <<   circleDiscs[discIdx.x][discIdx.y].x << "," << circleDiscs[discIdx.x][discIdx.y].y << ")" << endl;
	return ScalarPoint(returnX, returnY);
}

void formationCircle::updateCirclePos(){
	for (int i=0;i<50;++i) {
		GameObj* gob = getGobInSlot(i);
		gobCirclePos[gob->get_obj_id(gob)] = circleSlots[i];
	}
}
	
void formationCircle::addTarget(GameObj* gob) {
	//cout << "healthpoint ?!: " << (gob->get_val("hp")).to_int();
	potTargets.insert(make_pair((gob->get_val("hp")).to_int(), gob));
}

void formationCircle::updateTargetList(GameStateModule* gsm) {
	potTargets.clear();
	
	const Game &game = gsm->get_game();
  const sint4 cid = game.get_client_player();
  //const sint4 npc = game.get_player_num();
  //const Map<GameTile> &map = game.get_map();
  const Game::ObjCont &objs = game.get_objs((int)fabs(cid-1));
  //const sint4 points_x = map.get_width()  * game.get_tile_points();
  //const sint4 points_y = map.get_height() * game.get_tile_points(); 
	
  FORALL (objs, it) {
  	GameObj *gob = (*it)->get_GameObj();
  	if (gob && gob->sod.in_game && *gob->sod.x >= 0 && !gob->is_dead()) {
  		if(gob->bp_name() == "marine")
  			potTargets.insert(make_pair((gob->get_val("hp")).to_int(),gob));
  	}
  }
}

void formationCircle::insertShooter(GameObj* gob) {
	myShooters.insert(gob);
}

void formationCircle::removeShooter(GameObj* gob) {
	myShooters.erase(gob);
}

