#include "GameStateModule.H"
#include "ShutDown.H"
#include "SDLinit.H"
#include "Game.H"

bool quit = false;

class SampleEventHandler : public EventHandler {
public:
  SampleEventHandler() {}
  bool handle_event(const Event &e) { 
    if (e.get_who() == GameStateModule::FROM
				&& e.get_what() == GameStateModule::STOP_MSG)
      quit = true;
		return true;
	}
};


int main(int argc, char **argv)
{
  signals_shut_down(true);  
  SDLinit::network_init();
  
  // create option objects (though we pass them no data)
  // and create modules

  GameStateModule::Options::add();
  Game::Options::add();  
  GameStateModule::Options gsmo;
  GameStateModule gsm(gsmo);
  
  SampleEventHandler* psev = new SampleEventHandler();

  // gsm events are handled in sev
  gsm.add_handler(psev);
  
  // connect game state module to server
  if (!gsm.connect()) ERR("connection problems");

	while ( ! quit )
		if (!gsm.recv_view()) SDL_Delay(1);

  return 0;
}
