#ifndef ForceField_H
#define ForceField_H

// $Id: ForceField.H,

// This is  not an ORTS file 

#include "Global.H"
#include "LowAI.H"
#include "EventHandler.H"
#include "ClientModule.H"
#include <GameObj.H>

#include <set>
#include <map>
#include <string>
#include "boost/smart_ptr.hpp"


class GameStateModule;

//-------------------------------------------------------------------

class ForceField : public EventHandler, public ClientModule
{

protected:
  GameStateModule &gsm;
  
	

  
public:
  ForceField(GameStateModule &gsm);
  ~ForceField();

  bool handle_event(const Event &e);
  void outputResult();
  
  void allocate(sint4 width_, sint4 height_) {
  	assert(width_ > 0 && height_ > 0);
    // delete [] fieldControlCenter;
    width = width_; height = height_;
    num = width * height;
    fieldControlCenter = new double[num];
    fieldRessources = new double[num];
    fieldBoundaries = new double[num];
    staticFieldOutbound = new double[num];
    dynamicFieldOutbound = new double[num];
    // fieldOutbound = new double[num];
  }

private:
	sint4 width, height, num;
  double *fieldControlCenter;
  double *fieldRessources;
	double *fieldBoundaries;
	double *staticFieldOutbound;
	double *dynamicFieldOutbound;
	// double *fieldOutbound;
	double *field;
	bool ffMinerals;
	bool ffBoundary;
	std::multimap <int, GameObj*> mineralClusters;
	int numMineralClusters;
	//std::multimap <int, GameObj*> boundaryClusters;
	int numBoundaryClusters;
	std::map<int, ScalarPoint> workerPos;
	std::map<int, ScalarPoint> sheepPos;
	std::vector<GameObj*> minerals;
	std::vector<GameObj*> workers;
		
	void imposeWorkerForce();
	void imposeSheepForce();
	void imposeBoundaryForce(GameObj *gob);
	void imposeMineralForceFieldNC();
	void compute_actions();
	void printField(const double *field, ScalarPoint pos, int offset);
	void printFieldGnuplot(const double *field);

	int boundaryForce;
	int ccForce;
	int mineralForce;
	int workerForce;
	int sheepForce;
	int interClusterDistance;
	int ccOffset;
	int workerOffset;
	int boundaryOffset;
	int sheepOffset;
	bool noMineralClustering;
	
	std::ofstream outFile;
	std::ofstream plotFile;
	std::ofstream debug;
	std::ofstream myWorkerData;
	
};




#endif
