// $Id: Predict.C,v 1.10 2006/07/26 21:21:24 

// This is not an ORTS file 

#include "Predict.H"   
#include "GameStateModule.H"
#include "Game.H"
#include "GameChanges.H"
#include "GameObj.H"
#include "GfxModule.H"
#include "TerrainModule.H"
#include <math.h>

#define PI 3.14159265
using namespace std;


//===================================================================

Predict::Predict(GameStateModule &gsm_) : gsm(gsm_)
{
	perceptFile.open("percepts.txt", ios::out);
}

//===================================================================

Predict::~Predict()
{
	perceptFile.close();
}

//===================================================================

bool Predict::handle_event(const Event &e)
{

  if (e.get_who() == GameStateModule::FROM) {

    if (e.get_what() == GameStateModule::VIEW_MSG) {

      const sint4 me = gsm.get_game().get_client_player();
      const sint4 tile_points = gsm.get_game().get_tile_points();
      
      
      // new objects
      FORALL (gsm.get_changes().new_objs, i) {
        GameObj *gob = (*i)->get_GameObj();
        if (gob == 0) continue;
//        if (*gob->sod.owner != me) continue;
		
				perceptFile << "[";
				perceptFile << gsm.get_game().get_view_frame() ;
				perceptFile << ", '+', 'location', '";
				perceptFile << gob->bp_name();
				perceptFile << gob->get_obj_id(gob);
				perceptFile << "', ";
				perceptFile << "'(" << *gob->sod.x / (2*tile_points);
				perceptFile << "," << *gob->sod.y / (2*tile_points);
				perceptFile << ")'";
				perceptFile << "]" << endl;	
      }

	 		FORALL (gsm.get_changes().changed_objs, i) {
	 		
				GameObj *gob = (*i)->get_GameObj();
        if (gob == 0) continue;
        //if (*gob->sod.owner != me) continue;
		
		
				// object changed position from one tile to another tile
				if (*gob->sod.x / (2*tile_points) != gob->sod.prev.x / (2*tile_points) ||
						*gob->sod.y / (2*tile_points) != gob->sod.prev.y / (2*tile_points) )    {
					perceptFile << "[";
					perceptFile << gsm.get_game().get_view_frame() ;
					perceptFile << ", '-', 'location', '";
					perceptFile << gob->bp_name();
					perceptFile << gob->get_obj_id(gob);
					perceptFile << "', ";
					perceptFile << "'(" << gob->sod.prev.x / (2*tile_points); 
					perceptFile << "," << gob->sod.prev.y / (2*tile_points) << ")'"; 
					perceptFile << "]" << endl;	
					
					perceptFile << "[";
					perceptFile << gsm.get_game().get_view_frame() ;
					perceptFile << ", '+', 'location', '";
					perceptFile << gob->bp_name();
					perceptFile << gob->get_obj_id(gob);
					perceptFile << "', ";
					perceptFile << "'(" << *gob->sod.x / (2*tile_points);
					perceptFile << "," << *gob->sod.y / (2*tile_points);
					perceptFile << ")'";
					perceptFile << "]" << endl;	
				}
				
				// object changed speed
				if (*gob->sod.speed != gob->sod.prev.speed) {
					// object started movement
					if (gob->sod.prev.speed == 0) {
				
						perceptFile << "[";
						perceptFile << gsm.get_game().get_view_frame() ;
						perceptFile << ", '+', 'speed', '";
						perceptFile << gob->bp_name();
						perceptFile << gob->get_obj_id(gob);
						perceptFile << "', '";
						perceptFile << *gob->sod.speed;
						perceptFile << "']" << endl;	
						
						// gob->print(cout); 	
									
						//cout << "[ + ";
						//cout << gsm.get_game().get_view_frame() ;
						//cout << " head ";
						//cout << gob->bp_name();
						//cout << gob->get_obj_id(gob);
						//cout << " ";
						//cout << heading;
						//cout << endl;		
					}	
					// object stopped movement
					else if (*gob->sod.speed == 0) {
						perceptFile << "[";
						perceptFile << gsm.get_game().get_view_frame() ;
						perceptFile << ", '-', 'speed', '";
						perceptFile << gob->bp_name();
						perceptFile << gob->get_obj_id(gob);
						perceptFile << "', '";
						perceptFile << gob->sod.prev.speed;
						perceptFile << "']" << endl;	
						
						
					}
					// object changed speed
					else {
						perceptFile << "[";
						perceptFile << gsm.get_game().get_view_frame() ;
						perceptFile << ", '-', 'speed', '";
						perceptFile << gob->bp_name();
						perceptFile << gob->get_obj_id(gob);
						perceptFile << "', '";
						perceptFile << gob->sod.prev.speed;
						perceptFile << "']" << endl;	
						
						perceptFile << "[";
						perceptFile << gsm.get_game().get_view_frame() ;
						perceptFile << ", '+', 'speed', '";
						perceptFile << gob->bp_name();
						perceptFile << gob->get_obj_id(gob);
						perceptFile << "' ,'";
						perceptFile << *gob->sod.speed;
						perceptFile << "']" << endl;	
					}
					
					//heading = atan2(*gob->sod.y - gob->sod.prev.y, 
					//								*gob->sod.x - gob->sod.prev.x) * 180/PI;	
				}
				
				
	 		}
      
      // dead objects
//      FORALL (gsm.get_changes().dead_objs, i) {
//        GameObj *gob = (*i)->get_GameObj();
//        if (gob == 0) continue;
//        if (gob->bp_name() == "mineral")       del_res(gob);
//        if (*gob->sod.owner != me) continue;
//        stop(gob);
//	if (gob->bp_name() == "controlCenter"
//	    || gob->bp_name() == "pantheon_acropolis"
//	    || gob->bp_name() == "mound"
//           || gob->bp_name() == "tor"
//	    || gob->bp_name() == "citadel") del_base("mineral", gob);
//      }
      
      

      return true;
    }
  }

  return false;
}




