// $Id: LocalWorker.h,v 1.1 2007/04/25 20:40:29 shstoyko Exp $

#ifndef LOCAL_WORKER_H
#define LOCAL_WORKER_H

#include "GameObj.H"

enum States {IDLE,
            WALKING_TO_MINERAL,
            WALKING_TO_MINERAL_STUCK,
            MINING,
            WALKING_TO_CONTROL_CENTER,
            WALKING_TO_CONTROL_CENTER_STUCK,
            RETURNING_RESOURCES};

class LocalWorker{

public:
  LocalWorker(GameObj *gob);
  ~LocalWorker();

  void setGOB(GameObj* gob);
  GameObj* getGOB();

  void setState(States state);
  States getState();

  void setTargetMineral(GameObj* targetMineral);
  GameObj* getTargetMineral();
 
  void setTX(sint4 x);
  sint4 getTX();
 
  void setTY(sint4 Y);
  sint4 getTY();

  void setAttempt(int attempt);
  int getAttempt();

  void moveTo(sint4 x, sint4 y);
  void moveToTargetMineral();
  void moveToXY();

  void mine();
  void returnResource();

private:
  GameObj *gob;
  States state;
  GameObj* targetMineral;
  sint4 tx;
  sint4 ty;
  int attempt;


};

#endif
