// $Id: Net_InvitList.C,v 1.1.1.1 2007/04/09 19:05:53 pjungkun Exp $

/** (c) Michael Buro 2003, mburo@cs.ualberta.ca, licensed under the GPL */

#include "Net_InvitList.H"
using namespace std;

Net_InvitList::Net_InvitList(sint4 maxSize){
  MAX_SIZE = maxSize;
  size = 0;
}

Net_InvitList::~Net_InvitList() { }

sint4 Net_InvitList::add(Net_Invitation *n)
{
  /** find an empty spot */
  for(uint4 i = 0; i < list.size(); i++) {
    if(!present[i]){
      n->setIID(i);

      list.erase(list.begin()+i);
      list.insert(list.begin()+i, n);
      present[i] = true;

      size++;
      //n.updateinfo();
      return i;
    }
  }

  /* no empty spot, put it at the end, if the size isnt too big */
  if(list.size() == MAX_SIZE){
    REM("Max number of games reached");
    return -1;
  }

  n->setIID(list.size());
  list.push_back(n);
  present.push_back(true);
  size++;
  //n.updateinfo();
  return list.size()-1;
}


void Net_InvitList::del(uint4 iid){
  if (iid >= list.size()) return;
  present[iid] = false;
  size--;
  delete list[iid];
  list[iid]=0;
}


Net_Invitation* Net_InvitList::get(uint4 iid){

  if (iid >= list.size() || !present[iid]){
    //Net_Invitation dummy;
    return NULL;
  }else{
    return (list[iid]);
  }
  
}


string Net_InvitList::listGames() { return "list of games Ta Ta !"; }


void Net_InvitList::print(){
  if(size == 0){ 
    cout << "\nNo pending games" << endl;
    return;
  }
  cout << "\nPending Games " << "size : " << size << endl;
  FORU (i, list.size()) {
    if (present[i]) list[i]->print();
  }
}


/** fixme: maintain dont compute*/
const string Net_InvitList::getInfoList() const {
  string infoList;

  FORU(i, list.size()){
    if (present[i] && !list[i]->getInvisible()){  /**fixme: send invisible games to buddies*/
      infoList += list[i]->getInfo();
      infoList += " ";
    }
  }

  return infoList;
}
