// $Id: Net_InvitList.H,v 1.1.1.1 2007/04/09 19:05:53 pjungkun Exp $

// (c) Michael Buro 2003, mburo@cs.ualberta.ca, licensed under the GPL

/**
 * keeps the list of games
 */
	
#ifndef Net_InvitList_H
#define Net_InvitList_H

#include "Global.H"
#include "Net_Invitation.H"


class Net_InvitList
{

public:

  
  /**
   * \brief does nothing
   * for the default call by derived classes
   */
  Net_InvitList(sint4 maxSize = 100);

  virtual ~Net_InvitList();

  /**
     adds a game to the list
     @return returns the iid of the game, if too many invitations are currently on the list
     -1 is returned
  */
  sint4 add(Net_Invitation *n);

  /**
     removes game from the list
  */
  void del(uint4 iid);

  /**
     @param found set to false if not found true otherwise
     @return the game with from the list
  */
  Net_Invitation* get(uint4 iid);

  /**
     returns a list of all the current invitations
  */
  std::string listGames();

  void print();

  uint4 getSize() const {return list.size();}
  const std::string getInfoList () const ;
  
protected:

 
  uint4 MAX_SIZE;
  uint4 size;
  Vector<Net_Invitation*> list;
  Vector<uint1> present;

};

#endif


