// $Id: netservice_main.C,v 1.1.1.1 2007/04/09 19:05:53 pjungkun Exp $

/** (c) Michael Buro 2003, mburo@cs.ualberta.ca, licensed under the GPL */

#if 0
#ifndef _MSC_VER
#include <unistd.h>
#endif
#endif

#include "Options.H"
#include "Net_Service.H"

using namespace std;


/**
  add the desired options to the Options object
*/
static void add_options()
{
  Options o("Net Service");
  o.put("-db",           string("Service_database.db"),     "the data base file to be loaded/created");
  o.put("-verbose",      bool(true),                        "print out what the worker is doing");
  o.put("-rootnick",     string("sami"),                    "the ggs nick of root" );
  o.put("-rootpass",     string("sami"),                    "the password to verify root" );
  o.put("-servicenick",  string("service"),                 "the ggs nick of the service" );
  o.put("-servicepass",  string("service"),                 "the ggs password of the service" );
  o.put("-server",       string("opal.cs.ualberta.ca"),     "the the address of ggs server" );
  o.put("-port",         sint4(5000),                       "the port at which ggs is listening" );
}

/**
  get the options desired by the user
  and run the service
*/
int main(int argc, char **argv)
{
  signals_shut_down(false);
  
  add_options();

  // opt returns 0 if the parsing is successful
  if (Options::process(argc, argv, cerr, "VERSION 1.0")) exit(20);
  
  // initialize SDL
  if (SDL_Init(0)==-1) { ERR2("SDL_Init: ", SDL_GetError()); }
  
  // initialize SDL_net
  if(SDLNet_Init()==-1){ ERR2("SDLNet_Init: ", SDLNet_GetError()); }

  string nick;
  Options::get("-servicenick", nick);

  string pass;
  Options::get("-servicepass", pass);
  
  string root;
  Options::get("-rootnick", root);

  string rootPass = "sami";
  Options::get("-rootpass", rootPass);

  string server;
  Options::get("-server", server);

  string dbFile;
  Options::get("-db", dbFile);
  
  sint4 port;
  Options::get("-port", port);

  bool verbose;
  Options::get("-verbose", verbose);
  
  Net_Service THE_SERVICE = Net_Service(server, port, nick, pass, dbFile, root, rootPass, verbose);
  THE_SERVICE.start();
}
