// $Id: MyHandler.C,v 1.1.1.1 2007/04/09 19:06:19 pjungkun Exp $

// This is an ORTS file (c) Jonathan Yip, licensed under the GPL

#include "MyHandler.H"
#include "Game.H"
#include "GameObj.H"

using namespace std;

MyHandler::MyHandler(Client *client_, OSL::Program *program_) :
  client(client_), program(program_)
{
}

#define TYPE_UNIT 1

void MyHandler::handle_event(const std::string &from, const std::string &what)
{
  const Game& game = client->get_game();
  player_num = game.get_client_player();

  const Game::ObjCont &obj_cont = game.get_objs(player_num);
  FORU (i, obj_cont.size()) {
  //  FORU(i, 100) {
    GameObj &gob = *obj_cont[i];

    if (gob.sod.max_speed == 0) continue;


    std::vector<OSL::Value> o_params;
    OSL::Value v;
    v.cat = OSL::Type::TC_sint4;
    v.v_sint4 = gob.get_int("x");

    o_params.push_back(v);
    OSL::Value ret = program->run("foo", "bar", o_params);
    program->write_value(ret);

    
    Vector<sint4> params;
    params.push_back(v.v_sint4 + ret.v_sint4);
    //cout << v.v_sint4 << " " << ret.v_sint4 << endl;
    //    params.push_back(gob.get_int("x") + 1);
    params.push_back(gob.get_int("y") + 1);
    gob.set_action("move", params);
    
  }

  //  std::cout << from << " & " << what << std::endl;
  
  
}
