#ifndef BENCHCAM_H
#define BENCHCAM_H

#include <stdlib.h>
#include <stdio.h>
#include <sys/timeb.h>
#include <math.h>
#include <GL/glut.h>

class benchcam {
public:
    benchcam(int);
    benchcam(int, double, double, double);
    ~benchcam();

    void apply_rotation();
    void apply_translation();
    void apply_transform();
    void update();
    void update_mouse_moved(int, int);
    void update_mouse_pressed(int, int, int, int);
    void set_keyboard_array(unsigned char *);

    bool is_moving() const;

    void set_speed(double s) { speed = s; }

    double getX() { return _x; }
    double getY() { return _y; }
    double getZ() { return _z; }
    double getYaw() { return yaw; }
    double getPitch() { return pitch; }
    double getFPS() { return fps; }
    
    enum { RECORD, PLAYBACK };

private:

    // data

    static int num_frames;
    timeb timeA;

    double fps;
    double speed;
    double _x,_y,_z;
    double mx, my;
    double prev_mx, prev_my;

    double vx, vy, vz;

    double yaw, vyaw;
    double pitch, vpitch;

    bool rotation_active;
    bool mouse_differential_reset;
    bool recording;

    static double pi_o_180;

    unsigned char *keys;
    int mode;
    int tracking_counter;

    // methods

    // used by constructors
    void init(int);

    double *tracking_info;

};

#endif
