#ifndef SweepEventHandler_H
#define SweepEventHandler_H

// $Id: SweepEventHandler.H,v 1.1 2007/04/24 22:19:32 cjdarken Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "EventHandler.H"
#include "Random.H"

class GameStateModule;
class GfxModule;
class GUI;

// This class gives the event handler access to all game and gfx data

struct SampleAIState {

  GameStateModule *gsm;
  GfxModule       *gfxm; // !=0 : gfx used
  GUI             *gui;  // !=0 : debug gfx used
  bool just_drew;  // just drew a gfx frame
  bool quit;       // true => quit game
  bool error;      // true <=> error occurred

	bool isInitialized;
	sint4 sweepPos;
  bool leftToRight;
  
  SampleAIState(GameStateModule *gsm_, GfxModule *gfxm_, GUI *gui_) :
    gsm(gsm_), gfxm(gfxm_), gui(gui_)
  {
    just_drew = quit = error = false;
    isInitialized = false; // uninitialized
  }

};


// This class handles server events
// In particular it generates game object actions

class SweepEventHandler : public EventHandler {

public:
  
  SampleAIState &state;

  SweepEventHandler(SampleAIState &state_, sint4 seed) : state(state_) {
    rand.srand(seed);
  }

  bool handle_event(const Event &e);

private:
  
  void compute_actions();
  Random rand; // local RNG
  
};

#endif
