/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <iostream>
#include <ctime>
#include "../../../libs/kernel/src/Random.H"
using namespace std;

void MainWindow::fileNew()
{
    MainWindow *mainWin = new MainWindow;
    mainWin->show();
}


bool MainWindow::maybeSave()
{
    if (modified) {
	int ret = QMessageBox::warning (this, tr("WorldEd"),
					tr("Do you want to save your changes?"),
					QMessageBox::Yes | QMessageBox::Default,
					QMessageBox::No,
					QMessageBox::Cancel | QMessageBox::Escape);
	if (ret == QMessageBox::Yes)
	    return fileSave();
	else if (ret == QMessageBox::Cancel)
	    return false;
    }
    return true;
}
    
  
void MainWindow::fileOpen()
{
  if (maybeSave()) {
    QString fileName =
      QFileDialog::getOpenFileName(".", fileFilters, this);
    if (!fileName.isEmpty())
      loadFile(fileName);
  }
}


void MainWindow::loadFile(const QString &fileName)
{
    if (readFile(fileName)) {
    setCurrentFile(fileName);
  }
}


bool MainWindow::readFile( const QString &fileName )
{
    QFile file(fileName);
    if (!file.open(IO_ReadOnly) ) {
	QMessageBox::warning(this, tr("WorldEd"),
			     tr("Cannot read file %1: \n%2.")
			     .arg(file.name() )
			     .arg(file.errorString() ) );
	return false;
    }
    return true;
}


bool MainWindow::fileSave()
{
  if (curFile.isEmpty() ) {
    return fileSaveAs();
  } else {
    saveFile(curFile);
    return true;
  }
}


void MainWindow::saveFile(const QString &fileName)
{
  if (writeFile(fileName)) 
  setCurrentFile(fileName);
}


bool MainWindow::writeFile(const QString &fileName)
{
    QFile file(fileName);
    if (!file.open(IO_WriteOnly)) {
	QMessageBox::warning(this, tr("WorldEd"),
			     tr("Cannot write file %1:\n%2.")
			     .arg (file.name())
			     .arg (file.errorString()));
	return false;
    }
    QDataStream out(&file);
    return true;
}

bool MainWindow::fileSaveAs()
{
    QString fileName =
	    QFileDialog::getSaveFileName(".",fileFilters, this);
    if (fileName.isEmpty () )
	return false;
    
    if (QFile::exists (fileName) ) {
	int ret = QMessageBox::warning (this, tr("WorldEd"),
					tr("File %1 already exists.\n"
					   "Do you want to overwrite it?")
					.arg (QDir::convertSeparators (fileName) ),
					QMessageBox::Yes | QMessageBox::Default,
					QMessageBox::No | QMessageBox::Escape);
	if (ret == QMessageBox::No)
	    return true;
    }
    if (!fileName.isEmpty () )
	saveFile(fileName);
    return true;
}


void MainWindow::filePrint()
{

}


void MainWindow::closeEvent(QCloseEvent *event)
{
    if (modified = true) {
	if (maybeSave() ) {
	    event->accept();
	} else {
	    event->ignore();
	}
    }
}


void MainWindow::editUndo()
{
 
}


void MainWindow::editRedo()
{

}


void MainWindow::editCut()
{
   /*editCopy();
    editDelete();*/
}


void MainWindow::editCopy()
{

}


void MainWindow::editPaste()
{
    
}


void MainWindow::editDelete()
{
    
}


void MainWindow::editFind()
{

}


void MainWindow::helpIndex()
{

}


void MainWindow::helpContents()
{

}


void MainWindow::helpAbout()
{
    /*QMessageBox::about( this, tr( " " ),
			tr( " " ) );*/

}



void MainWindow::setCurrentFile( const QString &fileName )
{
    curFile = fileName;
    modified = false;
    
    if (curFile.isEmpty() ) {
	setCaption(tr("WorldEd") );
    } else {
	setCaption(tr("%1-%2") .arg (strippedName(curFile) )
		   .arg (tr("WorldEd") ) );
	recentFiles.remove(curFile);
	recentFiles.push_front(curFile);
	updateRecentFileItems();
    }
}


QString MainWindow::strippedName(const QString &fullFileName)
{
    return QFileInfo(fullFileName).fileName();
}


void MainWindow::updateRecentFileItems()
{
  while ( (int) recentFiles.size() > MaxRecentFiles)
    recentFiles.pop_back();
  for (int i = 0; i < (int) recentFiles.size(); ++i) {
    QString text = tr("&%1 %2")
      .arg (i + 1)
      .arg (strippedName(recentFiles[i]));
    if (recentFileIds[i] == -1) {
      if (i == 0)
	fileMenu->insertItem(text, this,SLOT(openRecentFile(int)), 0, -1, fileMenu->count() - 2);
      //fileMenu->insertItem(text, receiver, slot, accelerator, id, index)
      fileMenu->setItemParameter(recentFileIds[i], i);
    } else {
      fileMenu->changeItem(recentFileIds[i], text);
    }
  }
}
/*
void MainWindow::init()
{
  modified = false;
}


void MainWindow::destroy()
{

}
*/

void MainWindow::changeTerrain()
{
    Worlded* w=Worlded::instance();
        
  
   cout<<"Terrain change: brush: "<< brushCombo->currentItem() << " change tiles: " <<  tilesCombo->currentItem()  << " water: " <<  WATERcombo->currentItem() <<  " cliff: " << CLIFFcombo->currentItem() <<" size: " <<  islandCombo->currentItem() * 100 + 100<< " nplayers: " <<  playerCombo->currentItem() + 1 << " convex: " << convexCombo->currentItem()  * 45<< endl;
    w->set_radius( brushCombo->currentItem());
    w->set_height( elevationCombo->currentItem());
    bool cliff = CLIFFcombo->currentItem();
    bool water = WATERcombo->currentItem();
    sint4 size = islandCombo->currentItem() * 100 + 100;
    sint4 n = playerCombo->currentItem() + 1;
    real8 convex = convexCombo->currentItem()  * 45;
    w->opt->set("-nplayers", n);
    w->opt->set("-cliff", cliff);
    w->opt->set("-island", size);
    w->opt->set("-convex", convex);
    w->opt->set("-water", water);
    w->set_tile(tilesCombo->currentItem() );
}


void MainWindow::GenerateIsland()
{
    changeTerrain();
    Worlded* world=Worlded::instance();
   cout << "New map" << endl;
    world->generate_map();
}
