#ifndef CircleEventHandler_H
#define CircleEventHandler_H

// $Id: CircleEventHandler.H,v 1.4 2007/05/26 07:01:08 pjungkun Exp $

// This is not an ORTS file 

#include "EventHandler.H"
#include "formationCircle.H"
#include "Random.H"
#include <GameObj.H>

class GameStateModule;
class GfxModule;
class GUI;

// This class gives the event handler access to all game and gfx data

struct SampleAIState {

  GameStateModule *gsm;
  GfxModule       *gfxm; // !=0 : gfx used
  GUI             *gui;  // !=0 : debug gfx used
  bool just_drew;  // just drew a gfx frame
  bool quit;       // true => quit game
  bool error;      // true <=> error occurred
  
  bool isInitialized;
	sint4 sweepPos;
  bool leftToRight;
  
  SampleAIState(GameStateModule *gsm_, GfxModule *gfxm_, GUI *gui_) :
    gsm(gsm_), gfxm(gfxm_), gui(gui_)
  {
    just_drew = quit = error = false;
    isInitialized = false; // uninitialized
  }

};


// This class handles server events
// In particular it generates game object actions


class CircleEventHandler : public EventHandler{


public:
 	const sint4 FROM;
  SampleAIState &state;

  CircleEventHandler(SampleAIState &state_, sint4 seed) : FROM ( EventFactory::new_who() ),state(state_) {
    rand.srand(seed);
    shot = false;
    cooldown = 7;
    
  }

  bool handle_event(const Event &e);

	
private:
  
  void compute_actions();
  void requestMoveMarines();
  Random rand; // local RNG
  std::vector<GameObj*> marines;
  std::map<GameObj*, int> opponents;
  
  bool shot;
  int cooldown;
  
};

#endif
