#ifndef FORMATIONCIRCLE_H
#define FORMATIONCIRCLE_H

#include "GameObj.H"
#include "Global.H"
#include <map>

class GameStateModule;
typedef std::map<int, ScalarPoint> Disc;

enum States {IDLE,
            FORMING_INITIAL_CIRCLE,
            FORMING_CIRCLE,
            MOVING,
            ROTATING,
            ATTACKING};

class formationCircle{

public:
	//formationCircle(ScalarPoint); 
	formationCircle();
	
	ScalarPoint getSlotPos(int );
	GameObj* getGobInSlot(int );
	ScalarPoint getGobPos(sint4);
	ScalarPoint getGobDiscPos(sint4);
	int getSlot(GameObj* );
	void setSlot(GameObj* , int );
	void setCenter(ScalarPoint);
	ScalarPoint getCenter();
	void moveCircle(GameStateModule*);
	void addTarget(GameObj* );
	void updateTargetList(GameStateModule*);
	void insertShooter(GameObj*);
	void removeShooter(GameObj*);
	void shoot(GameStateModule*);
	void updateCirclePos();
	void initializeDiscs();
	void rotateDiscs();
	ScalarPoint nextPos(GameStateModule* gsm);
	std::vector<GameObj*> requestPath;
	std::set<GameObj*> plannedPath;
	void moveMarine(GameObj*, ScalarPoint);
	bool isInFormation();
	bool isLocalSuperior();
	int targetsInCircleRange();
	ScalarPoint cogMyShooters(GameStateModule*);
	
	States state;

private:
	std::map<int, GameObj*> slotAssign;
	std::map<int, ScalarPoint> circleSlots;
	std::map<int, ScalarPoint> circleSlotsClose;
	Disc disc0;
	Disc disc1;
	Disc disc2;
	Disc disc3;
	std::map<int, Disc> circleDiscs;
	std::map<sint4, ScalarPoint> gobCirclePos;
	std::map<sint4, ScalarPoint> gobDiscSlot; // ScalarPoint used for Disc index: x=no of disc, y= no of slot
	std::map<int, ScalarPoint> circleIdxToDiscIdxMap;
	std::multimap<int, GameObj*> potTargets;
	std::set<GameObj*> myShooters;
	std::set<GameObj*> targetsInRange;
	std::set<GameObj*> marineWithTarget;
	std::set<GameObj*> marinesOnPos;
	std::set<GameObj*> marinesOffPos;
	
	int lastMove;
	
	ScalarPoint center;
	
	
	//temp
	bool close;
	
};

#endif
