// $Id$

#ifndef LOCAL_WORKER_H
#define LOCAL_WORKER_H

#include "GameObj.H"

// worker states
enum States {IDLE,
            WALKING_TO_MINERAL,
            WALKING_TO_MINERAL_STUCK,
            WALKING_TO_MINERAL_FINISHING,
            WALKING_TO_MINERAL_PF,
            MINING,
            WALKING_TO_CONTROL_CENTER,
            WALKING_TO_CONTROL_CENTER_STUCK,
            WALKING_TO_CONTROL_CENTER_FINISHING,
            WALKING_TO_CONTROL_CENTER_PF,
            RETURNING_RESOURCES};

// worker from agent perspective 
class LocalWorker{

public:
  LocalWorker(GameObj *gob);
  ~LocalWorker();

  void setGOB(GameObj* gob);
  GameObj* getGOB();

  void setState(States state);
  States getState();

  void setTargetMineral(GameObj* targetMineral);
  GameObj* getTargetMineral();
 
  void setTX(sint4 x);
  sint4 getTX();
 
  void setTY(sint4 Y);
  sint4 getTY();

  void setAttempt(int attempt);
  int getAttempt();

  void moveToXY();

  void mine(const Game &game);
  void returnResource(const Game &game, const GameObj* controlCenter);

private:
  GameObj *gob;
  States state;
  GameObj* targetMineral;
  sint4 tx;
  sint4 ty;
  int attempt;

  void moveTo(sint4 x, sint4 y);

};

#endif

