#ifndef MessageEvent_H
#define MessageEvent_H

// $Id: MessageEvent.H,v 1.2 2006/06/29 01:04:59 orts_mburo Exp $

#include "Global.H"
#include <qevent.h> 
#include "Net_Message.H"
#include "Net_Protocol.H"
using namespace std;

namespace EventType{
    static const int base               = 65432;
    
    static const int GEN                = base + 0;
    static const int LOGIN_OK           = base + 1;
    static const int LOGIN_FAIL         = base + 2;
    static const int REFRESH_INVIT      = base + 3;
    static const int REFRESH_BUDDIES    = base + 4;
    static const int REFRESH_PLAYERS    = base + 5;
    static const int REFRESH_USERS      = base + 6;
    static const int JOIN_OK            = base + 7;
    static const int JOIN_FAIL          = base + 8;
    static const int PLAYER_JOINED      = base + 9;
    static const int CREATE_OK          = base + 10;
    static const int PLAYER_LEFT        = base + 11;
    static const int YOU_LEFT           = base + 12;
    static const int NEW_CONTEXT        = base + 13;
    static const int TELL               = base + 14;
    static const int PLAYER_KICKED      = base + 15;
    static const int U_KICKED           = base + 16;
    static const int DISCONNECTED       = base + 17;
    
    static const int ERROR              = base + 18;
}

class MessageEvent : public QCustomEvent
{
public:
  
  MessageEvent(string message_, int id = EventType::GEN): QCustomEvent(id){
    message = message_;
    netMessage = NULL;
  }
  
  ~MessageEvent(){
  }
  
  string getMessage() const {return message;}
  Message_Base* getNetMessage(){ return netMessage; }
  
private:
  
  string message;
  Message_Base* netMessage;
};


class TellEvent : public MessageEvent
{
public:
  
  TellEvent (string sender_, string context_, string message_): MessageEvent(message_, EventType::TELL) {
    context = context_;
    sender = sender_;
  }
  
  ~TellEvent() {}
  
  const string&  getContext() const {return context;}
  const string&  getSender() const {return  sender;}
  
  
private:
  string context;
  string sender;
};

#endif
