#ifndef SquadCombatAIWidget_H
#define SquadCombatAIWidget_H

// $Id: SquadCombatAIWidget.H,v 1.1 2006/08/10 17:09:15 nicholas Exp $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "CGridBase.H"
#include "DrawOnTerrain.H"
#include "EventHandler.H"
#include "SquadCombatAI.H"

class GfxModule;

//===================================================================

class SquadCombatAIOverlay : public EventHandler {
private:

  const SquadCombatAI *sc;
  
  DrawOnTerrain dot;
  bool enabled;
  
  GfxModule *gfxm;
  
public:
  
  SquadCombatAIOverlay(const SquadCombatAI &scai, GfxModule &gfxm);
  
  bool is_enabled() const { return enabled; }
  void enable() { enabled = true; }
  void disable() { enabled = false; }
  void draw();
  
  bool handle_event(const Event &e);
};

//-----------------------------------------------------------------

class SquadCombatAIWidget : public CGridBase
{
private:

  SquadCombatAI *sc;
  SquadCombatAIOverlay *overlay;
  
public:
  
  SquadCombatAIWidget(SquadCombatAI &scai, GfxModule *gfxm=0);
  ~SquadCombatAIWidget();
  
  virtual stype event_key_down(stype key, stype mod, stype x, stype y);
  virtual stype draw();
};

//===================================================================

#endif
