// $Id: FPS.C,v 1.8 2006/08/05 22:20:10 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "FPS.H"

FPS::FPS(sint4 d) : list(d)
{
  sint4 now = SDL_GetTicks();
  interval = d;

  FORALL (list, i) *i = now;
  p = 0;
}

FPS::~FPS()
{
}

real8 FPS::update()
{
  sint4 p2 = (p+1) % interval;
  list[p] = SDL_GetTicks();

  real8 diff = (list[p] - list[p2])/1000.0;
    
  p = p2;
  fps = static_cast<real8>(interval) / diff;
  dt = 1.0/fps;

  return dt;
}
