#ifndef Frustum_H
#define Frustum_H

// $Id: Frustum.H,v 1.5 2007/03/26 20:36:49 kalf Exp $
 
// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class Coor3;

class Frustum {

public:

  void compute();
  bool aabox_intersects(const Coor3 &o, const Coor3 &d);
  bool sphere_intersects(const Coor3 &o, real4 radius);
  bool point_intersects(const Coor3 &o);

  boost::array<boost::array<real4,4>,6> m_Frustum;

protected:

  enum { A, B, C, D };
  enum { RIGHT, LEFT, BOTTOM, TOP, BACK, FRONT };

  void normalize_plane(boost::array<boost::array<real4,4>,6> &frustum, sint4 side);
};

#endif
