#ifndef Compress_H
#define Compress_H

/** @file Compress.H
    Compress and Decompress message strings.

    $Id: Compress.H,v 1.3 2005/05/11 00:26:18 orts_mburo Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/Compress.H,v $
*/

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

struct z_stream_s;

class Compress {

private:

  Compress(const Compress &) { ERR("what"); }
  Compress &operator=(const Compress &) { ERR("what"); }  

protected:

  static const uint4 N = 65536; // out_buffer size
  z_stream_s *pzs;
  sint1 *out_buffer;
  sint4 level;                  // compression level (max 9)
  
public:

  Compress(sint4 level_ = 9);
  virtual ~Compress();
  void init();  
  void init(sint4 level_);
  void doit(const std::string &input, std::string &output);
};


class Decompress {

private:

  Decompress(const Decompress &) { ERR("what"); }
  Decompress &operator=(const Decompress &) { ERR("what"); }  

protected:

  static const uint4 N = 65536;
  z_stream_s *pzs;
  sint1 *out_buffer;

public:

  Decompress();
  virtual ~Decompress();
  void init();
  bool doit(const std::string &input, std::string &output, sint4 expected_length=-1);
};

#endif
