#ifndef DrawOnTerrain2D_H
#define DrawOnTerrain2D_H

/** @file DrawOnTerrain2D.H
    Overly graphics for the 2D debug interface.

    $Id: DrawOnTerrain2D.H,v 1.2 2007/03/15 10:40:06 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/kernel/src/DrawOnTerrain2D.H,v $
*/

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "GUI.H"
#include "LinAlg.H"

//===================================================================

/** Draws simple information on the debug map. */

class DrawOnTerrain2D
{
protected:

  GUI *gui;

public:

  DrawOnTerrain2D(GUI *g);
  virtual ~DrawOnTerrain2D();

  void start();
  void end();

  virtual void draw_line(real4 x1, real4 y1, real4 x2, real4 y2, const Vec3<real4> &col, real4 width=1.0);
  virtual void draw_circle(real4 cx, real4 cy, real4 r, const Vec3<real4> &col, real4 width=1.0);

  virtual void draw_tile(sint4 tx, sint4 ty, const Vec3<real4> &col);

  virtual void draw_square(real4 x1, real4 y1, real4 x2, real4 y2, const Vec3<real4> &col);
};

//===================================================================

#endif
