/*
 *  mapFlatAbstraction.h
 *  hog
 *
 *  Created by Nathan Sturtevant on 6/10/05.
 *  Copyright 2005 Nathan Sturtevant, University of Alberta. All rights reserved.
 *
 */

#include "mapAbstraction.h"

#ifndef MAPFLATABSTRACTION_H
#define MAPFLATABSTRACTION_H

using namespace HOG;

class mapFlatAbstraction : public mapAbstraction {
public:
	mapFlatAbstraction(Map *_m);
	~mapFlatAbstraction();
	
	virtual bool pathable(node *from, node *to);
	
	// utility functions
	/** verify that the hierarchy is consistent */
	virtual void verifyHierarchy();
	
	// hierarchical modifications
	/** remove node from abstraction */
	virtual void removeNode(node *n);
	/** remove edge from abstraction */
  virtual void removeEdge(edge *e, unsigned int absLevel);
	/** add node to abstraction */
	virtual void addNode(node *n);
	/** add edge to abstraction */
	virtual void addEdge(edge *e, unsigned int absLevel);
	/** This must be called after any of the above add/remove operations. But the
		operations can be stacked followed by a single repairAbstraction call. */
  virtual void repairAbstraction();	
private:
		void buildConnectivityGroups();
		bool groupsValid;
		std::vector<int> groups;
};

#endif //  MAPFLATABSTRACTION_H
