//-----------------------------------------------------------------------------
/** @file error.h
    Base exception class.

    $Id: error.h,v 1.1 2006/12/31 04:09:41 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/pathfinding/ua_path_lib/src/error.h,v $
*/
//-----------------------------------------------------------------------------

#ifndef PATHFIND_ERROR_H
#define PATHFIND_ERROR_H

#include <exception>
#include <string>
#include <vector>

//-----------------------------------------------------------------------------

namespace PathFind
{
    using namespace std;

    /** Base class for exceptions. */
    class Error
        : public exception
    {
    public:
        Error()
        { }

        Error(const string& _what)
            : m_message(_what)
        { }

        ~Error() throw();
        
        void setMessage(const string& message)
        {
            m_message = message;
        }

        const char* what() const throw()
        {
            return m_message.c_str();
        }
        
    private:
        string m_message;
    };
}

//-----------------------------------------------------------------------------

#endif
